/*
 ==============================================================================================================================================
 Author      : CHEONG SE HANG (dit.dhc@lostcity-studio.com)
 Description : Extension to standard library.
 ==============================================================================================================================================
 */
#ifndef STDLIB_H_
#define STDLIB_H_
#include <stdlib.h>
/*---------------------------------------------------------------------------------------------------------------------------------------------
 *
 *                                                              Public Functions
 *
 *-------------------------------------------------------------------------------------------------------------------------------------------*/
/**
 * Allocate dynamic memory.
 * @param size          Number of bytes to be allocated.
 * @param filename      File name from source code.
 * @param line          Line number from source code.
 * @return Returns the pointer to allocated memory on success. Otherwise, returns NULL.
 */
void* Malloc ( size_t size, const char* filename, int line );




#endif /* STDLIB_H_ */
