/*
 ==============================================================================================================================================
 Author      : CHEONG SE HANG (dit.dhc@lostcity-studio.com)
 Description : The extension to time library.
 ==============================================================================================================================================
 */
#include "Pthread.h"
#include "Time.h"
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
/*---------------------------------------------------------------------------------------------------------------------------------------------
 *
 *                                                              Private Variables
 *
 *-------------------------------------------------------------------------------------------------------------------------------------------*/
static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;  /* Mutual exclusion lock for Time library. */




/*---------------------------------------------------------------------------------------------------------------------------------------------
 *
 *                                                              Public Functions
 *
 *-------------------------------------------------------------------------------------------------------------------------------------------*/
TIMER time2MS () {
    struct timeval tp;
    if ( gettimeofday( &tp, NULL ) < 0 )
        return 0;
    return tp.tv_sec * 1000 + tp.tv_usec / 1000;
}


INT32 time2Sec () {
    return time( NULL );
}


void time2Str ( char* out ) {
//    int len;
//    char* arr;
    Pthread_mutex_lock( &mutex, __FILE__, __LINE__ );
    time_t t = time( NULL );
    struct tm* local = localtime( &t );
    strcpy( out, asctime( local ) );
    out[ strlen( out ) - 1 ] = 0;
//    arr = asctime( local );
    Pthread_mutex_unlock( &mutex, __FILE__, __LINE__ );
//    len = strlen( arr ) - 1;
//    strncpy( out, arr, len );
//    strcpy( out, arr );
//    out[ len ] = '\0';
}


BOOL timeout ( TIMER clk, UINT32 ms ) {
    return time2MS() > clk + ms;
}
